#ifndef _COMMMATRIX_H
#define _COMMMATRIX_H

// represents a communication matrix

class CommMatrix {

  unsigned _ssz;
  unsigned _rsz;
  long* _mat;

public:

  CommMatrix(unsigned ssz=1, unsigned rsz=1);
  CommMatrix(CommMatrix* cm);
  ~CommMatrix();

  unsigned getSenderSize() const { return _ssz; }
  unsigned getReceiverSize() const { return _rsz; }

  void set(unsigned sid, unsigned rid, long val) {      _mat[sid*_rsz+rid] = val; }
  long get(unsigned sid, unsigned rid)   const { return _mat[sid*_rsz+rid]; }
  void add(unsigned sid, unsigned rid, long val) {      _mat[sid*_rsz+rid] += val; }
  void sub(unsigned sid, unsigned rid, long val) {      _mat[sid*_rsz+rid] -= val; }

  void dump() const;

private:
  long* _get_mat() const { return _mat; }

};


#endif
