#include "CommunicationScheduling.h"

paco_comScheduling::paco_comScheduling() {}    

paco_comScheduling::~paco_comScheduling() {}

paco_comSchedule*
paco_comScheduling::getSchedule(long id)
{
  _schedule_info_map_t::iterator it = _schedule_info_map.find(id);
  if (it != _schedule_info_map.end())
    {
	return it->second;
      }
    else
      return NULL;
  }

void
paco_comScheduling::setSchedule(long id, paco_comSchedule* cs)
{
  //  _schedule_info_map[id] = cs;
}

void 
paco_comScheduling::clearScheduleId(long id) throw (InvalidArgument)
{
  if (id<0)
    throw new InvalidArgument("clearScheduleMemeoryId expects an id >0");
  
#ifdef DEBUG_INTERNAL
  std::cerr <<"[INFO] clearing schedule memory Id "<<id<<endl;
#endif
  
  _schedule_info_map_t::iterator it = _schedule_info_map.find(id);
  if (it != _schedule_info_map.end())
    {
      delete _schedule_info_map[id];
      _schedule_info_map.erase(it);
    }
}

void
paco_comScheduling::clearAllSchedules()
{
#ifdef DEBUG_INTERNAL
  std::cerr <<"[INFO] clearing all schedule memories\n";
#endif
  for(_schedule_info_map_t::iterator it = _schedule_info_map.begin(); it!= _schedule_info_map.end(); it++)
    {
      delete it->second;
    }
  _schedule_info_map.clear();
}


void
paco_comScheduling::propageComMatrix(PaCO_operation* op, unsigned **comMatrix)
{
  std::cerr << "[Debug] doing all-2-all communication, #phases: " << op->mytopo.total << endl;
  int size_temp_vector = sizeof(unsigned) * op->serveur_topo_aller.total;;
  for (unsigned i = 0; i < op->mytopo.total; i++)
    {
      std::cerr << "[Debug] all-2-all phase: "<<i<<" sz:"<<size_temp_vector<< endl;
      op->my_com->paco_bcast((void*) comMatrix[i], size_temp_vector, i);
    }
}

void
paco_comScheduling::displayStatus()
{
  cerr << this << " ctopo: "<<_client_topo<<" - "<<_client_topo->total<< " stopo: "<<_server_topo<<" - "<<_server_topo->total << " map: "<< _schedule_info_map.size() << endl;
}
