#include "FabriqueManager.h"
#include <iostream>

paco_fabrique_manager::paco_fabrique_manager()
{
  pfthread = new paco_fabrique_manager_thread();
  pfcom   = new paco_fabrique_manager_com();
  pfdistribution = new paco_fabrique_manager_distribution();
  pfcomScheduling = new paco_fabrique_manager_comScheduling();
}

paco_fabrique_manager::~paco_fabrique_manager()
{
  delete pfcomScheduling;
  delete pfdistribution;
  delete pfcom;
  delete pfthread;
}

// thread

void
paco_fabrique_manager::register_thread(const ::std::string& fabname, paco_fabrique_thread* pf)
{
  pfthread->paco_register(fabname, pf);
}
paco_fabrique_thread*
paco_fabrique_manager::get_thread(const ::std::string& fabname)
{
  return pfthread->paco_get(fabname);
}

// com

void
paco_fabrique_manager::register_com(const ::std::string& fabname, paco_fabrique_com* pf)
{
  pfcom->paco_register(fabname, pf);
}
paco_fabrique_com*
paco_fabrique_manager::get_com(const ::std::string& fabname)
{
  return pfcom->paco_get(fabname);
}

// distribution

void
paco_fabrique_manager::register_distribution(const ::std::string& fabname, paco_fabrique_distribution* pf)
{
  pfdistribution->paco_register(fabname, pf);
}
paco_fabrique_distribution*
paco_fabrique_manager::get_distribution(const ::std::string& fabname)
{
  return pfdistribution->paco_get(fabname);
}

// comScheduling

void
paco_fabrique_manager::register_comScheduling(const ::std::string& fabname, paco_fabrique_comScheduling* pf)
{
  pfcomScheduling->paco_register(fabname, pf);
}
paco_fabrique_comScheduling*
paco_fabrique_manager::get_comScheduling(const ::std::string& fabname)
{
  return pfcomScheduling->paco_get(fabname);
}

