#ifndef PACO_FABRIQUE_MANAGER_IS_DEFINED
#define PACO_FABRIQUE_MANAGER_IS_DEFINED

#include "thread/paco_thread.h"
#include "com/paco_com.h"
#include "DistributionLibrairie.h"
#include "CommunicationScheduling.h"

#include <string>
#include <map>
#include <vector>

// Concrete fabrique class
class paco_fabrique_manager
{
 private:
  paco_fabrique_manager_thread*        pfthread;
  paco_fabrique_manager_com*           pfcom;
  paco_fabrique_manager_distribution*  pfdistribution;
  paco_fabrique_manager_comScheduling* pfcomScheduling;

 public:
  paco_fabrique_manager();
  ~paco_fabrique_manager();   

  // Thread
  void register_thread(const ::std::string& fabname, paco_fabrique_thread* pf);
  paco_fabrique_thread* get_thread(const ::std::string& fabname);

  // Com
  void register_com(const ::std::string& fabname, paco_fabrique_com* pf);
  paco_fabrique_com* get_com(const ::std::string& fabname);

  // Distribution
  void register_distribution(const ::std::string& fabname, paco_fabrique_distribution* pf);
  paco_fabrique_distribution* get_distribution(const ::std::string& fabname);

  // Com
  void register_comScheduling(const ::std::string& fabname, paco_fabrique_comScheduling* pf);
  paco_fabrique_comScheduling* get_comScheduling(const ::std::string& fabname);

};

#endif
