#ifndef PACO_FABRIQUE_IS_DEFINED
#define PACO_FABRIQUE_IS_DEFINED

#include <iostream>
#include <cstdlib>
#include <string>
#include <map>
#include <vector>

// Concrete fabrique must inherit from this type
template<class T> class paco_fabrique_manager_tpl {
protected:
  // Store the association name <-> fabrique
  typedef typename std::map<std::string, T*> fab_map_t;
  fab_map_t _fab_map;

public:

  paco_fabrique_manager_tpl() { _fab_map.clear(); }

  virtual ~paco_fabrique_manager_tpl() {};

  void paco_register(const ::std::string& fabname, T* pf)
  {    
    typename fab_map_t::iterator it = _fab_map.find(fabname);
    
    if (it == _fab_map.end() )
      {
	// Debug
	// cout << "Adding fab " << fabname << endl;
	_fab_map[fabname] = pf;
      }
    else
      {
	// Debug
	// cout << "Ignoring: already register fab " << fabname << endl;
      }
  }

  T* paco_get(const ::std::string& fabname) 
  {
    typename fab_map_t::iterator it = _fab_map.find(fabname);
    
    if (it == _fab_map.end() )
      {
	// Debug
	std::cerr << "Error: fab not found -- " << fabname << std::endl;
	std::abort();
      }
    else
      {
	return  it->second;
      }
	
  }
  
};

#endif
