#include "paco_direct_comScheduling.h"

////////////////////////////////////////////////////////////

paco_comSchedule_direct::paco_comSchedule_direct(int rank, int max, unsigned *local_com_vector,
						 void** info_vector[])
{
  _myrank=rank;
  _dst=new unsigned[max];
  _len=new unsigned[max];
  _inf=new void*[max];
  unsigned cur=0;
  for(int i=0;i<max; i++) {
    if (local_com_vector[i]>0) {
      _dst[cur]=i;
      _len[cur]=local_com_vector[i];
      _inf[cur]=info_vector[i];
      cur++;
    }
  }
  _nbelement=cur;
}

paco_comSchedule_direct::~paco_comSchedule_direct()
{
  delete _len;
  delete _dst;
  delete _inf;
}

////////////////////////////////////////////////////////////

paco_comScheduling_direct::~paco_comScheduling_direct()
{
}

paco_comSchedule* 
paco_comScheduling_direct::computeScheduling(unsigned rank, 
					     PaCO::PacoTopology_t* srctopo, PaCO::PacoTopology_t* dsttopo,
					     unsigned **com_matrix, void** info_vector[])
{
  //  cerr << __FUNCTION__ << " : rank: "<<rank<<" srvtopo: "<<dsttopo->total<<endl;
  return new paco_comSchedule_direct(rank, dsttopo->total, com_matrix[rank], info_vector);
}
