#ifndef DIRECT_COMSCHEDULE_IS_DEFINED
#define DIRECT_COMSCHEDULE_IS_DEFINED

#include <CommunicationScheduling.h> 

class paco_comSchedule_direct : public paco_comSchedule
{
protected:
  unsigned _myrank;
  unsigned _nbelement;
  unsigned *_dst;
  unsigned *_len;
  void*    *_inf;

public:
  paco_comSchedule_direct(int rank, int max, unsigned *loca_com_vector, void** info_vector[]);
  virtual ~paco_comSchedule_direct();

  unsigned int getNbPhases() { return 1; }
  unsigned int getElementPhase(const unsigned phase) { return _nbelement; }
  unsigned int getSrc(const unsigned phase, const unsigned id)  { return _myrank; }
  unsigned int getDst(const unsigned phase, const unsigned id)  { return _dst[id]; }
  unsigned int getSize(const unsigned phase, const unsigned id) { return _len[id]; }
         void* getInfo(const unsigned phase, const unsigned id) { return _inf[id]; }
};

class paco_comScheduling_direct :  public paco_comScheduling 
{

public:
  paco_comScheduling_direct() {};
  virtual ~paco_comScheduling_direct();

  paco_comSchedule* computeScheduling(unsigned rank,
				      PaCO::PacoTopology_t* srctopo, PaCO::PacoTopology_t* dsttopo,
				      unsigned **com_matrix, void** info_vector[]);

  void propageComMatrix(PaCO_operation* op, unsigned **comMatrix) { /* overloading all-2-all: no propagation  needed for direct */} 

};

class paco_direct_fabrique :  public paco_fabrique_comScheduling
{
 public:
   paco_comScheduling *create_comScheduling() {
    return new paco_comScheduling_direct();
  }
};

#endif
