#include "paco_omni.h"

paco_omni_thread::paco_omni_thread()
{
}

paco_omni_thread::~paco_omni_thread()
{
}

paco_omni_mutex::paco_omni_mutex()
{
  mutex = new omni_mutex();
}

paco_omni_mutex::~paco_omni_mutex()
{
  delete mutex;
}

void
paco_omni_mutex::lock()
{
  mutex->lock();
}

void
paco_omni_mutex::unlock()
{
  mutex->unlock();
}

paco_omni_condition::paco_omni_condition(paco_omni_mutex* m)
{
  condition = new omni_condition(m->mutex);
}

paco_omni_condition::~paco_omni_condition()
{
  delete condition;
}

void
paco_omni_condition::wait()
{
  condition->wait();
};

void
paco_omni_condition::signal()
{
  condition->signal();
};

paco_mutex* paco_omni_fabrique::paco_create_mutex() 
{
  return new paco_omni_mutex();
}

paco_condition* paco_omni_fabrique::paco_create_condition(paco_mutex * mutex) 
{
  return new paco_omni_condition((paco_omni_mutex*) mutex);
}

paco_thread * paco_omni_fabrique::paco_create_thread(void* (*fn)(void*), void* arg)
{
  //  paco_omni_thread * th = new paco_omni_thread();
  // to have a detached thread !
  void (*fn_detached)(void*) = (void (*)(void *))fn;
  //th->thread = omni_thread::create(fn_detached,arg);
   try
    {
  omni_thread::create(fn_detached,arg);
   }
  catch (omni_thread_fatal &e)
    {
      int end = 0;
      while (end != 1)
	{
	  cerr << "paco_create_thread error : " << e.error << endl;
	  end = end + 1;
	  omni_thread::sleep(2);
	  try
	    {
	      omni_thread::create(fn_detached,arg);
	    }
	  catch (omni_thread_fatal &e)
	    {
	      end = end - 1;
	    }
	}
    }
  //return th;
  return NULL;
}

paco_thread * paco_omni_fabrique::paco_create_thread(void (*fn)(void*), void* arg)
{
  try
    {
      omni_thread::create(fn,arg);
    }
  catch (omni_thread_fatal &e)
    {
      int end = 0;
      while (end != 1)
	{
	  cerr << "paco_create_thread error : " << e.error << endl;
	  end = end + 1;
	  omni_thread::sleep(2);
	  try
	    {
	      omni_thread::create(fn,arg);
	    }
	  catch (omni_thread_fatal &e)
	    {
	      end = end - 1;
	    }
	}
    }
  return NULL;
}
