#include "paco_thread.h"
#include <omnithread.h>

class paco_omni_thread : public paco_thread
{
 public:
  paco_omni_thread();
  virtual ~paco_omni_thread();
  
  virtual void detach() {thread->exit();}
  omni_thread * thread;
};

class paco_omni_mutex : public paco_mutex
{
 public:
  paco_omni_mutex();
  ~paco_omni_mutex();

  void lock();
  void unlock();

  omni_mutex * mutex;
};

class paco_omni_condition : public paco_condition
{
 public:
  paco_omni_condition(paco_omni_mutex* m);
  ~paco_omni_condition();

  void wait();
  void signal();

 private:
  omni_condition * condition;
};

class paco_omni_fabrique : public paco_fabrique_thread {

public:

  paco_mutex* paco_create_mutex();
  paco_condition* paco_create_condition(paco_mutex * mutex);
  paco_thread * paco_create_thread(void* (*fn)(void*), void* arg = NULL);
  paco_thread * paco_create_thread(void (*fn)(void*), void* arg = NULL);
};
