#include "paco_pthread.h"

paco_pthread_mutex::paco_pthread_mutex()
{
  pthread_mutex_init(&mutex, 0);
}

paco_pthread_mutex::~paco_pthread_mutex()
{
  pthread_mutex_destroy(&mutex);
}

void
paco_pthread_mutex::lock()
{
  pthread_mutex_lock(&mutex);
}

void
paco_pthread_mutex::unlock()
{
  pthread_mutex_unlock(&mutex);
}


paco_pthread_condition::paco_pthread_condition(paco_pthread_mutex* m)
{
  mutex = m;
  pthread_cond_init(&condition, 0);
}


paco_pthread_condition::~paco_pthread_condition()
{
  pthread_cond_destroy(&condition);
}

void
paco_pthread_condition::wait()
{
  pthread_cond_wait(&condition, &mutex->mutex);
}

void
paco_pthread_condition::signal()
{
  pthread_cond_signal(&condition);
}


paco_mutex* paco_pthread_fabrique::paco_create_mutex() 
{
  return new paco_pthread_mutex();
}

paco_condition* paco_pthread_fabrique::paco_create_condition(paco_mutex * mutex) 
{
  return new paco_pthread_condition((paco_pthread_mutex*) mutex);
}

paco_thread * paco_pthread_fabrique::paco_create_thread(void* (*fn)(void*), void* arg)
{
  pthread_attr_t attr;
  
  pthread_attr_init(&attr);
  pthread_attr_setdetachstate(&attr, PTHREAD_CREATE_DETACHED );

  paco_pthread_thread * th = new paco_pthread_thread();
  pthread_create(&th->thread, &attr, fn,arg);
  return th;
}
