#include "paco_thread.h"
#include <pthread.h>

class paco_pthread_thread : public paco_thread
{
 public:
  paco_pthread_thread() {}
  virtual ~paco_pthread_thread()
	{
		pthread_detach(thread);
	}

  pthread_t thread;
};

class paco_pthread_mutex : public paco_mutex
{
 public:
  paco_pthread_mutex();
  ~paco_pthread_mutex();

  void lock();
  void unlock();

  pthread_mutex_t mutex;
};

class paco_pthread_condition : public paco_condition
{
 public:
  paco_pthread_condition(paco_pthread_mutex* m);
  ~paco_pthread_condition();

  void wait();
  void signal();

 private:
  pthread_cond_t condition;
  paco_pthread_mutex * mutex;
};

class paco_pthread_fabrique : virtual public paco_fabrique_thread {

public:
  paco_mutex* paco_create_mutex(); 
  paco_condition* paco_create_condition(paco_mutex * mutex);
  paco_thread * paco_create_thread(void* (*fn)(void*), void* arg = NULL);
};
