#ifndef __PACO_thread__
#define __PACO_thread__

#include "FabriqueManagerTpl.h"
#include <string>
#include <map>
#include <iostream>

using namespace std;

////////////////////////////////////////

class paco_mutex 
{
 public:
  virtual ~paco_mutex() {};
  
  virtual void lock() = 0;
  virtual void unlock() = 0;
};

////////////////////////////////////////

class paco_condition
{
 public:
  virtual ~paco_condition() {};

  virtual void wait() = 0;
  virtual void signal() = 0;
};

////////////////////////////////////////

class paco_thread
{
 public:
  virtual ~paco_thread() {};
  virtual void detach() {};  
};

////////////////////////////////////////
////////////////////////////////////////
////////////////////////////////////////

////////////////////////////////////////
// Abstract class to be implemeted by each fabrique
class paco_fabrique_thread {

public:
  virtual ~paco_fabrique_thread() {}

  virtual paco_mutex* paco_create_mutex()=0;
  virtual paco_condition* paco_create_condition(paco_mutex * mutex)=0;
  // Create a joinable thread
  virtual paco_thread * paco_create_thread(void* (*fn)(void*), void* arg = NULL)=0; 
  // create a detached thread
  virtual paco_thread * paco_create_thread(void (*fn)(void*), void* arg = NULL)=0;
};

// The thread fabrique
typedef paco_fabrique_manager_tpl<paco_fabrique_thread> paco_fabrique_manager_thread;

#endif
